# Automatic Response Generation to Conversational Stimuli

Deep learning based generative models that make a machine comprehend to conversations and respond coherently.

#### Links:  
- __Project Guidelines__: [#1](https://github.com/sayhitosandy/Chatbot/blob/master/Backpack%20Files/projectguidelines_13032.pdf), [#2](https://github.com/sayhitosandy/Chatbot/blob/master/Backpack%20Files/interim-reportguidelines_14201.pdf), [#3](https://github.com/sayhitosandy/Chatbot/blob/master/Backpack%20Files/finalprojectreportandcodesubmission_15145.pdf)
- __Dataset__: [*The Cornell Movie Dialogs Corpus*](https://www.cs.cornell.edu/~cristian/Cornell_Movie-Dialogs_Corpus.html)
- __Presentation__: [*Mid-Evaluation*](https://github.com/sayhitosandy/Chatbot/blob/master/Mid%20Report/Automatic%20Response%20Generation%20to%20Conversational%20Stimuli.pdf), [*Final-Evaluation*](https://github.com/sayhitosandy/Chatbot/blob/master/Final%20Report/ML_PPT_Final.pdf)
- __Report__: [*Mid-Evaluation*](https://github.com/sayhitosandy/Chatbot/blob/master/Mid%20Report/2015085_InterimProjectReport.pdf), [*Final-Evaluation*](https://github.com/sayhitosandy/Chatbot/blob/master/Final%20Report/Final_Report_ML.pdf)
- __Output__: [*Plots*](https://github.com/sayhitosandy/Chatbot/tree/master/Final%20Report/Plots)

#### References:  
1. G. Corrado. Computer, respond to this email. https://research.googleblog.com/2015/11/computer-respond-to-this-email.html.
2. D. Currie. Bot tutorials, medium: How to build your first chat bot. https://tutorials.botsfloor.com/how-to-build-your-first-chatbot-c84495d4622d.
3. Deeplearning4j. A beginners guide to recurrent networks and lstms. https://deeplearning4j.org/lstm.html.
4. A. Kannan, K. Kurach, S. Ravi, T. Kaufman, B. Miklos, G. Corrado, A. Tomkins, L. Lukacs, M. Ganea, P. Young, and V. Ramavajjala. Smart reply: Automated response suggestion for email, 2016. https://research.google.com/pubs/pub45189.html.
5. Keras. A ten-minute introduction to seq2seq learning in keras. https://blog.keras.io/a-ten-minute-introductionto-sequence-to-sequence-learning-in-keras.html.
6. K. Papineni, S. Roukos, T. Ward, and W.-J. Zhu. Bleu: A method for automatic evaluation of machine translation. http://www.aclweb.org/anthology/P02-1040.pdf.
7. I. Sutskever, O. Vinyals, and Q. V. Le. Sequence to sequence learning with neural networks. http://arxiv.org/abs/1409.3215.
8. T. Tran. Creating a language translation model using sequence to sequence learning approach. https://chunml.github.io/ChunML.github.io/project/Sequence-To-Sequence/.
9. T. Tran. Creating a text generator using recurrent neural network. https://chunml.github.io/ChunML.github.io/project/Creating-Text-Generator-Using-Recurrent-Neural-Network/.
10. O. Vinyals and Q. V. Le. A neural conversational model, 2015. https://arxiv.org/pdf/1506.05869.pdf.
